%define section free

Summary:        OSGI Framework
Name:           knopflerfish
Version:        1.3.3
Release:        1jpp
Epoch:          0
License:        BSD Style
URL:            http://www.knopflerfish.org
Group:          Development/Libraries/Application Frameworks
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        knopflerfish_osgi_1.3.3.jar
Patch0:         knopflerfish_osgi_build_xml.patch
BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.6
BuildRequires:  bcel
BuildRequires:  nanoxml
BuildRequires:  oscar
BuildRequires:  servletapi3
Requires:  bcel
Requires:  nanoxml
Requires:  oscar
Requires:  servletapi3

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The Knopflerfish OSGi framework is a complete, 
open source, OSGi R3 framework.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -c -q -n %{name}_osgi_%{version}
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
#for j in $(find . -name "*.jar"); do
#    mv $j $j.no
#done

%patch0 -b .sav

%build
cd knopflerfish.org
export CLASSPATH=$(build-classpath \
bcel \
nanoxml \
oscar/osgi \
oscar/bundle/shell \
servletapi3 \
)
ant -Dbuild.sysclasspath=first all htdocs javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/bundles
install -m 644 knopflerfish.org/osgi/framework.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/framework-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/prefs/prefs_api-1.0.0.jar  \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/prefs_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/prefs/prefs_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/prefs_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/frameworkcommands/frameworkcommands-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/frameworkcommands-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/desktop/desktop_all-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/desktop_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/desktop/desktop_api-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/desktop_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/desktop/desktop-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/desktop-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/device/device_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/device_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/device/device-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/device-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/device/device_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/device_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/log/log_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/log_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/log/log_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/log_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/log/log-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/log-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/http/http_api-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/http_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/http/http-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/http-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/http/http_all-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/http_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/kf_metatype/kf_metatype-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/kf_metatype-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/kf_metatype/kf_metatype_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/kf_metatype_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/consoletty/consoletty-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/consoletty-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/util/util-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/util-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/httproot/httproot-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/httproot-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/httpconsole/httpconsole-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/httpconsole-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/basicdriverlocator/basicdriverlocator-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/basicdriverlocator-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/consoletelnet/consoletelnet-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/consoletelnet-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/crimson/crimson-1.1.3.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/crimson-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/trayicon_fw/trayicon_fw-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/trayicon_fw-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/measurement/measurement-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/measurement-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/provisioning/provisioning_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/provisioning_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/cm_desktop/cm_desktop-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/cm_desktop-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/upnp/upnp_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/upnp_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/logcommands/logcommands-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/logcommands-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/cm/cm_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/cm_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/cm/cm_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/cm_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/cm/cm-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/cm-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/useradmin/useradmin-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/useradmin-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/useradmin/useradmin_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/useradmin_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/useradmin/useradmin_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/useradmin_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/cm_cmd/cm_cmd-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/cm_cmd-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/jsdk/jsdk-2.2.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/jsdk-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/demo1client/demo1client-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/demo1client-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/trayicon/trayicon_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/trayicon_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/trayicon/trayicon_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/trayicon_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/demo1/demo1_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/demo1_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/demo1/demo1-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/demo1-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/demo1/demo1_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/demo1_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/consoletcp/consoletcp-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/consoletcp-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/xml/xml-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/xml-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/metatype/metatype-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/metatype-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/position/position-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/position-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/remotefw/remotefw_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/remotefw_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/bundlerepository/bundlerepository_all-1.1.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundlerepository_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/console/console-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/console-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/console/console_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/console_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/console/console_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/console_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/sslj2sp/sslj2sp_all-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/sslj2sp_all-%{version}.jar
install -m 644 knopflerfish.org/osgi/jars/wireadmin/wireadmin_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/wireadmin_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/bundles/desktop/resources/jarunpacker.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundles/jarunpacker-%{version}.jar
install -m 644 knopflerfish.org/osgi/bundles/desktop/resources/remotefw_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundles/remotefw_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/bundles/desktop/resources/console_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundles/console_api-%{version}.jar
install -m 644 knopflerfish.org/osgi/bundles/desktop/resources/log_api-1.0.0.jar \
			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundles/log_api-%{version}.jar
#install -m 644 knopflerfish.org/osgi/bundles/bundlerepository/resources/console_api-1.0.0.jar \
#			$RPM_BUILD_ROOT%{_javadir}/%{name}/bundles/console_api-%{version}.jar
#install -m 644 knopflerfish.org/tools/jarunpacker/out/jarunpacker/jarunpacker.jar \
#			$RPM_BUILD_ROOT%{_javadir}/%{name}


(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/bundle && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr knopflerfish.org/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


rm -rf knopflerfish.org/htdocs/build.xml

# docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr knopflerfish.org/htdocs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/*.txt
%{_javadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Tue Oct 25 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.3.3-1jpp
- First JPP release
